import { world, system } from '@minecraft/server'

world.beforeEvents.worldInitialize.subscribe(initEvent => {
       initEvent.blockComponentRegistry.registerCustomComponent('true:collection', {
       onPlayerInteract: eventData => {
          const block = eventData.block
          const player = eventData.player
          const blockLocation = block.location;
          const blockPos = block.location;
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:banana_crop") {
           block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
           system.run(() => {
           block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/crops/banana/crops"`);
           }
         )
       }
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:apple_crop") {
          block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
          system.run(() => {
          block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/crops/apple/crops"`);
          }
        )
      }
      if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:orange_crop") {
          block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
          system.run(() => {
          block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/crops/orange/crops"`);
         }
       )
     }
     if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:pear_crop") {
         block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
         system.run(() => {
         block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/crops/pear/crops"`);
         }
       )
      }
     if (block.permutation.getState('true:stage') == 4 && block.typeId == "true:lemon_crop") {
        block.setPermutation(block.permutation.withState('true:stage', block.permutation.getState('true:stage') - 4))
        system.run(() => {
        block.dimension.runCommandAsync(`loot spawn ${blockLocation.x} ${blockLocation.y - 1.0} ${blockLocation.z} loot "blocks/crops/lemon/crops"`);
        }
      )
     }
    }
   }
  )
 }
)
world.beforeEvents.worldInitialize.subscribe(eventData => {
       eventData.blockComponentRegistry.registerCustomComponent('true:growth', {
       onTick: eventData => {
         const block = eventData.block
         const age = block.permutation.getState('true:stage')
       if (age < 4) {
         block.setPermutation(block.permutation.withState('true:stage', age + 1))
         }
       }
     }
   )
 }  
)
world.beforeEvents.worldInitialize.subscribe(initEvent => {
       initEvent.blockComponentRegistry.registerCustomComponent('true:tree_bonemeal', {
       onPlayerInteract: eventData => {
          const block = eventData.block
          const player = eventData.player
          const blockPos = block.location;
          const item = eventData.player.getComponent('equippable').getEquipment('Mainhand')
      if (item?.typeId == "minecraft:bone_meal" && block.typeId == "true:orange_tree_sapling") {
           system.run(() => {
           player.runCommandAsync(`structure load orange_tree_grown ${blockPos.x - 4} ${blockPos.y} ${blockPos.z - 4}`)
           player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 0.5} ${blockPos.z}`);
           player.runCommandAsync(`clear @s bone_meal 0 1`);
           }
         )
       }
      if (item?.typeId == "minecraft:bone_meal" && block.typeId == "true:apple_tree_sapling") {
           system.run(() => {
           player.runCommandAsync(`structure load apple_tree_grown ${blockPos.x - 4} ${blockPos.y} ${blockPos.z - 4}`)
           player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 0.5} ${blockPos.z}`);
           player.runCommandAsync(`clear @s bone_meal 0 1`);
           }
         )
       }
      if (item?.typeId == "minecraft:bone_meal" && block.typeId == "true:banana_tree_sapling") {
           system.run(() => {
           player.runCommandAsync(`structure load banana_tree_grown ${blockPos.x - 5} ${blockPos.y} ${blockPos.z - 5}`)
           player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 0.5} ${blockPos.z}`);
           player.runCommandAsync(`clear @s bone_meal 0 1`);
           }
         )
       }
      if (item?.typeId == "minecraft:bone_meal" && block.typeId == "true:pear_tree_sapling") {
           system.run(() => {
           player.runCommandAsync(`structure load pear_tree_grown ${blockPos.x - 4} ${blockPos.y} ${blockPos.z - 4}`)
           player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 0.5} ${blockPos.z}`);
           player.runCommandAsync(`clear @s bone_meal 0 1`);
           }
         )
       }
      if (item?.typeId == "minecraft:bone_meal" && block.typeId == "true:lemon_tree_sapling") {
           system.run(() => {
           player.runCommandAsync(`structure load lemon_tree_grown ${blockPos.x - 2} ${blockPos.y} ${blockPos.z - 2}`)
           player.runCommandAsync(`particle minecraft:crop_growth_emitter ${blockPos.x} ${blockPos.y + 0.5} ${blockPos.z}`);
           player.runCommandAsync(`clear @s bone_meal 0 1`);
           }
         )
       }
     }
   }
  )
 }
)
world.beforeEvents.worldInitialize.subscribe(eventData => {
       eventData.blockComponentRegistry.registerCustomComponent('true:tree_growth', {
       onTick: eventData => {
         const block = eventData.block
         const blockPos = block.location;
      if (block.typeId == "true:orange_tree_sapling") {
          system.run(() => {
          block.dimension.runCommandAsync(`structure load orange_tree_grown ${blockPos.x - 4} ${blockPos.y} ${blockPos.z - 4}`)
          }
         )
       }
      if (block.typeId == "true:apple_tree_sapling") {
          system.run(() => {
          block.dimension.runCommandAsync(`structure load apple_tree_grown ${blockPos.x - 4} ${blockPos.y} ${blockPos.z - 4}`)
          }
         )
       }
     if (block.typeId == "true:pear_tree_sapling") {
          system.run(() => {
          block.dimension.runCommandAsync(`structure load pear_tree_grown ${blockPos.x - 4} ${blockPos.y} ${blockPos.z - 4}`)
          }
         )
       }
     if (block.typeId == "true:lemon_tree_sapling") {
          system.run(() => {
          block.dimension.runCommandAsync(`structure load lemon_tree_grown ${blockPos.x - 2} ${blockPos.y} ${blockPos.z - 2}`)
          }
         )
       }
     if (block.typeId == "true:banana_tree_sapling") {
          system.run(() => {
          block.dimension.runCommandAsync(`structure load banana_tree_grown ${blockPos.x - 5} ${blockPos.y} ${blockPos.z - 5}`)
          }
         )
       }
      }
     }
   )
 }  
)